/*
  Register definitions for slave core: Mock Turtle CPU Control/Status registers block

  * File           : mockturtle_cpu_csr.h
  * Author         : auto-generated by wbgen2 from ../../../hdl/rtl//cpu/mt_cpu_csr.wb
  * Created        : Mon Jul 16 14:52:30 2018
  * Standard       : ANSI C

    THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE ../../../hdl/rtl//cpu/mt_cpu_csr.wb
    DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!

*/

#ifndef __WBGEN2_REGDEFS___/__/__/HDL/RTL//CPU/MT_CPU_CSR_WB
#define __WBGEN2_REGDEFS___/__/__/HDL/RTL//CPU/MT_CPU_CSR_WB

#include <inttypes.h>

#if defined( __GNUC__)
#define PACKED __attribute__ ((packed))
#else
#error "Unsupported compiler?"
#endif

#ifndef __WBGEN2_MACROS_DEFINED__
#define __WBGEN2_MACROS_DEFINED__
#define WBGEN2_GEN_MASK(offset, size) (((1<<(size))-1) << (offset))
#define WBGEN2_GEN_WRITE(value, offset, size) (((value) & ((1<<(size))-1)) << (offset))
#define WBGEN2_GEN_READ(reg, offset, size) (((reg) >> (offset)) & ((1<<(size))-1))
#define WBGEN2_SIGN_EXTEND(value, bits) (((value) & (1<<bits) ? ~((1<<(bits))-1): 0 ) | (value))
#endif


/* definitions for register: Core Reset Register */

/* definitions for register: Core Notification Interrupt Register */

/* definitions for register: Core 0-3 Notification Value Register */

/* definitions for register: Core 4-7 Notification Value Register */

/* definitions for register: SMEM Operation Select */

/* definitions for register: HMQ Select Register */

/* definitions for field: Queue select in reg: HMQ Select Register */
#define MT_CPU_CSR_HMQ_SEL_QUEUE_MASK         WBGEN2_GEN_MASK(0, 3)
#define MT_CPU_CSR_HMQ_SEL_QUEUE_SHIFT        0
#define MT_CPU_CSR_HMQ_SEL_QUEUE_W(value)     WBGEN2_GEN_WRITE(value, 0, 3)
#define MT_CPU_CSR_HMQ_SEL_QUEUE_R(reg)       WBGEN2_GEN_READ(reg, 0, 3)

/* definitions for field: Core select in reg: HMQ Select Register */
#define MT_CPU_CSR_HMQ_SEL_CORE_MASK          WBGEN2_GEN_MASK(8, 3)
#define MT_CPU_CSR_HMQ_SEL_CORE_SHIFT         8
#define MT_CPU_CSR_HMQ_SEL_CORE_W(value)      WBGEN2_GEN_WRITE(value, 8, 3)
#define MT_CPU_CSR_HMQ_SEL_CORE_R(reg)        WBGEN2_GEN_READ(reg, 8, 3)

/* definitions for register: HMQ IN Status Core 0-3 Register */

/* definitions for register: HMQ IN Status Core 4-7 Register */

/* definitions for register: HMQ OUT Status Core 0-3 Register */

/* definitions for register: HMQ OUT Status Core 4-7 Register */

/* definitions for register: HMQ IN Interrupt Enable Core 0-3 Register */

/* definitions for register: HMQ IN Interrupt Enable Core 4-7 Register */

/* definitions for register: HMQ OUT Interrupt Enable Core 0-3 Register */

/* definitions for register: HMQ OUT Interrupt Enable Core 4-7 Register */

/* definitions for register: Core Select Register */

/* definitions for register: Core Upload Address Register */

/* definitions for field: Address to access in selected core's local memory. in reg: Core Upload Address Register */
#define MT_CPU_CSR_UADDR_ADDR_MASK            WBGEN2_GEN_MASK(0, 20)
#define MT_CPU_CSR_UADDR_ADDR_SHIFT           0
#define MT_CPU_CSR_UADDR_ADDR_W(value)        WBGEN2_GEN_WRITE(value, 0, 20)
#define MT_CPU_CSR_UADDR_ADDR_R(reg)          WBGEN2_GEN_READ(reg, 0, 20)

/* definitions for register: Core Upload Data Register */

/* definitions for register: Core Serial Console Message Register */

/* definitions for field: Serial console message byte for the selected core in reg: Core Serial Console Message Register */
#define MT_CPU_CSR_UART_MSG_DATA_MASK         WBGEN2_GEN_MASK(0, 8)
#define MT_CPU_CSR_UART_MSG_DATA_SHIFT        0
#define MT_CPU_CSR_UART_MSG_DATA_W(value)     WBGEN2_GEN_WRITE(value, 0, 8)
#define MT_CPU_CSR_UART_MSG_DATA_R(reg)       WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for register: Core Serial Console Message Poll Register */

/* definitions for field: Serial console message data available in reg: Core Serial Console Message Poll Register */
#define MT_CPU_CSR_UART_POLL_READY_MASK       WBGEN2_GEN_MASK(0, 8)
#define MT_CPU_CSR_UART_POLL_READY_SHIFT      0
#define MT_CPU_CSR_UART_POLL_READY_W(value)   WBGEN2_GEN_WRITE(value, 0, 8)
#define MT_CPU_CSR_UART_POLL_READY_R(reg)     WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for register: Core Serial Console Message Interrupt Mask Register */

/* definitions for field: Per-Core Serial console message Interrupt Enable in reg: Core Serial Console Message Interrupt Mask Register */
#define MT_CPU_CSR_UART_IMSK_ENABLE_MASK      WBGEN2_GEN_MASK(0, 8)
#define MT_CPU_CSR_UART_IMSK_ENABLE_SHIFT     0
#define MT_CPU_CSR_UART_IMSK_ENABLE_W(value)  WBGEN2_GEN_WRITE(value, 0, 8)
#define MT_CPU_CSR_UART_IMSK_ENABLE_R(reg)    WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for register: Debug Interface Status Register */

/* definitions for register: Debug Interface Force Register */

/* definitions for register: Debug Interface Instruction Ready Register */

/* definitions for register: Debug Interface Core[0] Instruction Register */

/* definitions for register: Debug Interface Core[1] Instruction Register */

/* definitions for register: Debug Interface Core[0] Mailbox Data Register */

/* definitions for register: Debug Interface Core[1] Mailbox Data Register */
/* [0x0]: REG Core Reset Register */
#define MT_CPU_CSR_REG_RESET 0x00000000
/* [0x4]: REG Core Notification Interrupt Register */
#define MT_CPU_CSR_REG_INT 0x00000004
/* [0x8]: REG Core 0-3 Notification Value Register */
#define MT_CPU_CSR_REG_INT_VAL_LO 0x00000008
/* [0xc]: REG Core 4-7 Notification Value Register */
#define MT_CPU_CSR_REG_INT_VAL_HI 0x0000000c
/* [0x18]: REG SMEM Operation Select */
#define MT_CPU_CSR_REG_SMEM_OP 0x00000018
/* [0x1c]: REG HMQ Select Register */
#define MT_CPU_CSR_REG_HMQ_SEL 0x0000001c
/* [0x40]: REG HMQ IN Status Core 0-3 Register */
#define MT_CPU_CSR_REG_HMQI_STATUS_LO 0x00000040
/* [0x48]: REG HMQ IN Status Core 4-7 Register */
#define MT_CPU_CSR_REG_HMQI_STATUS_HI 0x00000048
/* [0x60]: REG HMQ OUT Status Core 0-3 Register */
#define MT_CPU_CSR_REG_HMQO_STATUS_LO 0x00000060
/* [0x68]: REG HMQ OUT Status Core 4-7 Register */
#define MT_CPU_CSR_REG_HMQO_STATUS_HI 0x00000068
/* [0x80]: REG HMQ IN Interrupt Enable Core 0-3 Register */
#define MT_CPU_CSR_REG_HMQI_INTEN_LO 0x00000080
/* [0x88]: REG HMQ IN Interrupt Enable Core 4-7 Register */
#define MT_CPU_CSR_REG_HMQI_INTEN_HI 0x00000088
/* [0x90]: REG HMQ OUT Interrupt Enable Core 0-3 Register */
#define MT_CPU_CSR_REG_HMQO_INTEN_LO 0x00000090
/* [0x98]: REG HMQ OUT Interrupt Enable Core 4-7 Register */
#define MT_CPU_CSR_REG_HMQO_INTEN_HI 0x00000098
/* [0xc0]: REG Core Select Register */
#define MT_CPU_CSR_REG_CORE_SEL 0x000000c0
/* [0xc4]: REG Core Upload Address Register */
#define MT_CPU_CSR_REG_UADDR 0x000000c4
/* [0xc8]: REG Core Upload Data Register */
#define MT_CPU_CSR_REG_UDATA 0x000000c8
/* [0x100]: REG Core Serial Console Message Register */
#define MT_CPU_CSR_REG_UART_MSG 0x00000100
/* [0x104]: REG Core Serial Console Message Poll Register */
#define MT_CPU_CSR_REG_UART_POLL 0x00000104
/* [0x108]: REG Core Serial Console Message Interrupt Mask Register */
#define MT_CPU_CSR_REG_UART_IMSK 0x00000108
/* [0x180]: REG Debug Interface Status Register */
#define MT_CPU_CSR_REG_DBG_STATUS 0x00000180
/* [0x184]: REG Debug Interface Force Register */
#define MT_CPU_CSR_REG_DBG_FORCE 0x00000184
/* [0x188]: REG Debug Interface Instruction Ready Register */
#define MT_CPU_CSR_REG_DBG_INSN_READY 0x00000188
/* [0x18c]: REG Debug Interface Core[0] Instruction Register */
#define MT_CPU_CSR_REG_DBG_CORE0_INSN 0x0000018c
/* [0x190]: REG Debug Interface Core[1] Instruction Register */
#define MT_CPU_CSR_REG_DBG_CORE1_INSN 0x00000190
/* [0x194]: REG Debug Interface Core[0] Mailbox Data Register */
#define MT_CPU_CSR_REG_DBG_CORE0_MBX 0x00000194
/* [0x198]: REG Debug Interface Core[1] Mailbox Data Register */
#define MT_CPU_CSR_REG_DBG_CORE1_MBX 0x00000198
#endif
